.386
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc
include ws2_32.inc
include masm32.inc
include debug.inc

includelib kernel32.lib
includelib user32.lib
includelib ws2_32.lib
includelib masm32.lib
includelib debug.lib

WinMain		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
CheckSum	PROTO	:DWORD,:DWORD
ShowData	PROTO	:DWORD

WaitForConnect	PROTO	:DWORD
ConnectDlgProc	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
NickDlgProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD

m2m MACRO p1,p2
	push p2
	pop p1
endm
.const
Ctrl_Data	equ	1001
Ctrl_Msg	equ	1002
Ctrl_Send	equ	1003

Dlg_Connect	equ	5001
Dlg_Nick	equ	5002

IdLabel1	equ	1001
Ctrl_Host	equ	1002
Ctrl_Connect equ 1003
IdLabel2	equ	1004
Ctrl_Nick	equ	1005

Menu_Connect equ 2001
Menu_Listen	equ	2002
Menu_Exit	equ	2003

Id_Label1	equ	501
Id_Label2	equ	502

WM_SOCKET	equ	WM_USER+100
SIO_RCVALL	equ	98000001h

CHAT_CONNECT	equ	96
CHAT_OK			equ	97
CHAT_READY		equ	98
CHAT_DATA		equ	99
CHAT_CLOSE		equ	100

CHAT_NONE	equ	0
CHAT_SERVER	equ	1
CHAT_CLIENT	equ	2
CHAT_COMM	equ	3
ICMPHDR STRUCT
  icmp_type   BYTE      ?
  icmp_code   BYTE      ?
  icmp_cksum  WORD      ?
  icmp_id     WORD      ?
  icmp_seq    WORD      ?
; icmp_data   BYTE      ?
ICMPHDR ENDS

ChatPacket STRUCT
	icmphdr	ICMPHDR		<?>
	data	db	1000 dup(0)
ChatPacket ends
.data
AppName		db	"Stealth Chat",0
IconName	db	"AppIcon",0
MenuName	db	"AppMenu",0
ClassName	db	"Net_Window_Class",0
SendBtn		db	"Send",0
EditClass	db	"edit",0
ButtonClass	db	"button",0
StaticClass	db	"static",0

MenuConnect		db	"&Connect to Host",0
MenuDisconnect	db	"Dis&connect",0
MenuListen		db	"&Wait for Connection",0
MenuStopListen	db	"Stop &Waiting",0

Label1		db	"Chat Window:",0
Label2		db	"Message:",0

Colon		db	":",0
CRLF		db	13,10,0
MessageData		db	"%s: %s",13,10,0
Msg_Connecting	db	"Connecting to %s",13,10,0
Msg_Connected	db	"Connected to %s",13,10,0
Msg_Incoming	db	"Incoming connection from %s",13,10,0

Err_EnterHost	db	"You must enter a hostname/ip",0
Err_EnterNick	db	"You must enter a nickname",0
Err_NoHost		db	"Cannot resolve hostname",0
Err_Connect		db	"You must connect before chatting",0
Err_FailConnect	db	"Failed to connect to %s",13,10,0

Connected	db	FALSE
Waiting		db	FALSE
chatState	dd	0
chatType	dd	0

addrLen		dd	SIZEOF sockaddr_in
SendBuffer	ChatPacket	<>
.data?
hInstance	HINSTANCE	?
hDataView	HANDLE	?
hMessage	HANDLE	?
hSend		HANDLE	?
sock		SOCKET	?
hostsock	SOCKET	?
hostAddr	DWORD	?
hostSeq		WORD	?
clientAddr	DWORD	?

wsadata		WSADATA		<?>
incoming	sockaddr_in	<?>
outgoing	sockaddr_in	<?>

Message		db	768	dup(?)
RecvBuffer	db	600 dup(?)
ShowBuffer	db	600 dup(?)
HostBuffer	db	256 dup(?)
NickName	db	75	dup(?)
client		db	20	dup(?)
.code
start:
	invoke GetModuleHandle,0
	mov hInstance,eax
	invoke WSAStartup,202h,ADDR wsadata
	invoke WinMain,hInstance,0,0,0
	invoke WSACleanup
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov wc.cbSize,SIZEOF WNDCLASSEX
	mov wc.style,CS_VREDRAW+CS_HREDRAW
	mov wc.lpfnWndProc,OFFSET WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	m2m wc.hInstance,hInst
	invoke LoadIcon,hInst,ADDR IconName
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	mov wc.hbrBackground,COLOR_BACKGROUND+10
	mov wc.lpszMenuName,OFFSET MenuName
	mov wc.lpszClassName,OFFSET ClassName
	invoke RegisterClassEx,ADDR wc
	invoke CreateWindowEx,0,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,150,50,350,400,0,0,hInst,0
	mov hwnd,eax
	invoke ShowWindow,hwnd,SW_SHOW
	invoke UpdateWindow,hwnd
	.WHILE TRUE
		invoke GetMessage,ADDR msg,0,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg
	.ENDW
	mov eax,msg.wParam
	Ret
WinMain EndP
WndProc proc uses esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL TimeOut:timeval
LOCAL readfds:fd_set
LOCAL hMenu:HMENU
LOCAL hFileMenu:HMENU
LOCAL optVal:DWORD, bytes:DWORD, ThreadId:DWORD
.IF uMsg==WM_INITMENUPOPUP
	mov eax,lParam
	and eax,0ffffh
	.if ax==0
		m2m hFileMenu,wParam
		.if Connected
			invoke ModifyMenu,hFileMenu,Menu_Connect,MF_BYCOMMAND+MF_STRING,Menu_Connect,ADDR MenuDisconnect
		.elseif !Connected
			invoke ModifyMenu,hFileMenu,Menu_Connect,MF_BYCOMMAND+MF_STRING,Menu_Connect,ADDR MenuConnect
		.endif
		.if Waiting
			invoke ModifyMenu,hFileMenu,Menu_Listen,MF_BYCOMMAND+MF_STRING,Menu_Listen,ADDR MenuStopListen
		.else
			invoke ModifyMenu,hFileMenu,Menu_Listen,MF_BYCOMMAND+MF_STRING,Menu_Listen,ADDR MenuListen
		.endif
		.if Connected
			invoke EnableMenuItem,hFileMenu,Menu_Listen,MF_GRAYED+MF_BYCOMMAND
		.elseif !Connected
			invoke EnableMenuItem,hFileMenu,Menu_Listen,MF_ENABLED+MF_BYCOMMAND
		.endif
		.if Waiting
			invoke EnableMenuItem,hFileMenu,Menu_Connect,MF_GRAYED+MF_BYCOMMAND
		.elseif !Waiting
			invoke EnableMenuItem,hFileMenu,Menu_Connect,MF_ENABLED+MF_BYCOMMAND
		.endif
	.endif
.ELSEIF uMsg==WM_COMMAND
	mov eax,wParam
	.if ax==Menu_Exit
		invoke SendMessage,hWnd,WM_CLOSE,0,0
	.elseif ax==Menu_Listen
		.if !Waiting
			invoke DialogBoxParam,hInstance,Dlg_Nick,hWnd,ADDR NickDlgProc,0
			.if eax==0
				mov Connected,FALSE
				ret
			.endif
			invoke socket,AF_INET,SOCK_RAW,IPPROTO_IP
			mov sock,eax
			mov Waiting,TRUE
			mov incoming.sin_addr,INADDR_ANY
			invoke bind,sock,ADDR incoming,SIZEOF sockaddr_in
			invoke WSAAsyncSelect,sock,hWnd,WM_SOCKET,FD_READ
			mov chatState,CHAT_SERVER
			mov chatType,CHAT_SERVER
			invoke SetFocus,hMessage
		.else
			invoke closesocket,sock
			mov Waiting,FALSE
		.endif
	.elseif ax==Menu_Connect
		.if !Connected
			invoke DialogBoxParam,hInstance,Dlg_Connect,hWnd,ADDR ConnectDlgProc,0
			.if eax==0
				mov Connected,FALSE
				ret
			.endif
			invoke socket,AF_INET,SOCK_RAW,IPPROTO_ICMP
			mov sock,eax
			mov incoming.sin_addr,INADDR_ANY
			invoke bind,sock,ADDR incoming,SIZEOF sockaddr_in
			mov SendBuffer.icmphdr.icmp_type,CHAT_CONNECT
			mov SendBuffer.icmphdr.icmp_id,0
			invoke GetCurrentProcessId
			mov SendBuffer.icmphdr.icmp_seq,ax
			lea eax,SendBuffer.data
			invoke szCopy,ADDR NickName,eax
			mov SendBuffer.icmphdr.icmp_cksum,0
			invoke CheckSum,ADDR SendBuffer,SIZEOF ChatPacket
			mov SendBuffer.icmphdr.icmp_cksum,ax
			
			m2m outgoing.sin_addr.S_un.S_addr,hostAddr
			mov outgoing.sin_family,AF_INET
			invoke sendto,sock,ADDR SendBuffer,SIZEOF ChatPacket,0,ADDR outgoing,SIZEOF sockaddr_in
			mov incoming.sin_family,AF_INET
			invoke wsprintf,ADDR ShowBuffer,ADDR Msg_Connecting,ADDR HostBuffer
			invoke ShowData,ADDR ShowBuffer
;			mov readfds.fd_count,1
;	
;			mov eax,sock
;			mov readfds.fd_array,eax
;			mov TimeOut.tv_sec,5
;			mov TimeOut.tv_usec,0
;			invoke select,1,ADDR readfds,0,0,ADDR TimeOut
;			.if eax==0
;				invoke closesocket,sock
;				invoke wsprintf,ADDR ShowBuffer,ADDR Err_FailConnect,ADDR HostBuffer
;				invoke ShowData,ADDR ShowBuffer
;				mov Connected,FALSE
;				ret
;			.endif
;tryagain:	invoke recvfrom,sock,ADDR RecvBuffer,600,0,ADDR incoming,ADDR addrLen
;			mov esi,OFFSET RecvBuffer
;			add esi,SIZEOF ip_hdr
;			assume esi:ptr ChatPacket
;			movzx eax,[esi].icmphdr.icmp_seq
;			mov hostSeq,ax
;			invoke GetCurrentProcessId
;			.if ax!=hostSeq
;				ret
;			.endif
;			movzx eax,[esi].icmphdr.icmp_type
;			mov chatState,CHAT_COMM
;			.if eax==CHAT_OK
;				invoke wsprintf,ADDR ShowBuffer,ADDR Msg_Connected,ADDR HostBuffer
;				invoke ShowData,ADDR ShowBuffer
;				mov chatState,CHAT_COMM
;				mov Connected,TRUE
;			.elseif eax==CHAT_CONNECT
;				mov eax,sock
;				mov readfds.fd_array,eax
;				mov TimeOut.tv_sec,10
;				mov TimeOut.tv_usec,0
;				invoke select,1,ADDR readfds,0,0,ADDR TimeOut
;				.if eax==0
;					invoke closesocket,sock
;					invoke wsprintf,ADDR ShowBuffer,ADDR Err_FailConnect,ADDR HostBuffer
;					invoke ShowData,ADDR ShowBuffer
;					mov Connected,FALSE
;					ret
;				.endif
;;				jmp tryagain
;			.else
;				invoke closesocket,sock
;				invoke wsprintf,ADDR ShowBuffer,ADDR Err_FailConnect,ADDR HostBuffer
;				invoke ShowData,ADDR ShowBuffer
;				mov Connected,FALSE
;				mov chatState,CHAT_NONE
;			.endif
			mov Connected,TRUE
			mov chatType,CHAT_CLIENT
			invoke WSAAsyncSelect,sock,hWnd,WM_SOCKET,FD_READ
			invoke SetFocus,hMessage
		.else
			invoke closesocket,sock
			mov Connected,FALSE
		.endif
		
	.elseif ax==Ctrl_Send
		.if hostAddr==0&&clientAddr==0
			invoke ShowData,ADDR Err_Connect
			ret
		.endif
		invoke memfill,ADDR Message,768,0
		invoke GetWindowText,hMessage,ADDR Message,767
		.if eax==0
			ret
		.endif
		lea eax,SendBuffer.data
		invoke szMultiCat,4,eax,ADDR CRLF,ADDR NickName,ADDR Colon,ADDR Message 
		mov SendBuffer.icmphdr.icmp_type,CHAT_DATA
		mov SendBuffer.icmphdr.icmp_id,0
		.if chatType==CHAT_SERVER
			m2m SendBuffer.icmphdr.icmp_seq,hostSeq
		.else
			invoke GetCurrentProcessId
			mov SendBuffer.icmphdr.icmp_seq,ax
		.endif
		mov SendBuffer.icmphdr.icmp_cksum,0
		invoke CheckSum,ADDR SendBuffer,SIZEOF ChatPacket
		mov SendBuffer.icmphdr.icmp_cksum,ax
		
		.if hostAddr!=0
			m2m outgoing.sin_addr.S_un.S_addr,hostAddr
		.else
			m2m outgoing.sin_addr.S_un.S_addr,clientAddr
		.endif
		mov outgoing.sin_family,AF_INET
		mov chatState,CHAT_COMM
		invoke sendto,sock,ADDR SendBuffer,SIZEOF ChatPacket,0,ADDR outgoing,SIZEOF sockaddr_in
		invoke SetWindowText,hMessage,0
		invoke SetFocus,hMessage
	.endif
.ELSEIF uMsg==WM_SOCKET
	mov eax,lParam
	.if ax==FD_READ
		invoke recvfrom,sock,ADDR RecvBuffer,600,0,ADDR incoming,ADDR addrLen
		mov esi,OFFSET RecvBuffer
		.if chatState==CHAT_SERVER
			m2m clientAddr,(ip_hdr ptr [esi]).ip_src
			add esi,SIZEOF ip_hdr
			assume esi:ptr ChatPacket
			movzx eax,[esi].icmphdr.icmp_type
			mov chatState,CHAT_COMM
			.if eax==CHAT_CONNECT
				mov ax,SendBuffer.icmphdr.icmp_seq
				mov hostSeq,ax
				invoke GetCurrentProcessId
				.if ax==hostSeq
					ret
				.endif
				mov SendBuffer.icmphdr.icmp_type,CHAT_OK
				mov SendBuffer.icmphdr.icmp_id,0
				movzx eax,[esi].icmphdr.icmp_seq
				mov SendBuffer.icmphdr.icmp_cksum,0
				invoke CheckSum,ADDR SendBuffer,SIZEOF ChatPacket
				mov SendBuffer.icmphdr.icmp_cksum,ax
				mov incoming.sin_family,AF_INET
				m2m incoming.sin_addr.S_un.S_addr,clientAddr
				invoke sendto,sock,ADDR SendBuffer,SIZEOF ChatPacket,0,ADDR incoming,SIZEOF sockaddr_in
				invoke inet_ntoa,clientAddr
				.if eax==0
					ret
				.endif
				invoke wsprintf,ADDR ShowBuffer,ADDR Msg_Incoming,eax
				invoke ShowData,ADDR ShowBuffer
				invoke SetFocus,hMessage
			.elseif eax==CHAT_OK
				ret
			.else
				invoke closesocket,sock
				mov Waiting,FALSE
			.endif
		.elseif chatState==CHAT_CLIENT
			invoke recvfrom,sock,ADDR RecvBuffer,600,0,ADDR incoming,ADDR addrLen
			mov esi,OFFSET RecvBuffer
			add esi,SIZEOF ip_hdr
			assume esi:ptr ChatPacket
			movzx eax,[esi].icmphdr.icmp_seq
			mov hostSeq,ax
			invoke GetCurrentProcessId
			.if ax==hostSeq
				ret
			.endif
			movzx eax,[esi].icmphdr.icmp_type
			mov chatState,CHAT_COMM
			.if eax==CHAT_OK
				invoke wsprintf,ADDR ShowBuffer,ADDR Msg_Connected,ADDR HostBuffer
				invoke ShowData,ADDR ShowBuffer
				mov chatState,CHAT_COMM
				mov Connected,TRUE
			.else
				invoke closesocket,sock
				invoke wsprintf,ADDR ShowBuffer,ADDR Err_FailConnect,ADDR HostBuffer
				invoke ShowData,ADDR ShowBuffer
				mov Connected,FALSE
			.endif
			invoke SetFocus,hMessage
		.else
			mov esi,OFFSET RecvBuffer
;			assume esi:ptr ip_hdr
;			lea eax,[esi].ip_src
;			invoke gethostbyaddr,eax,4,AF_INET
;			.if eax==0
;				ret
;			.endif
;			mov ebx,[eax]
			add esi,SIZEOF ip_hdr
			assume esi:ptr ChatPacket
			movzx eax,[esi].icmphdr.icmp_seq
			mov hostSeq,ax
;			invoke GetCurrentProcessId
;			.if (chatType==CHAT_CLIENT)&&(ax!=hostSeq)
;				ret
;			.elseif chatType==CHAT_SERVER||ax==hostSeq
;				ret
;			.endif
			mov al,[esi].icmphdr.icmp_type
			.if al==CHAT_DATA
				add esi,SIZEOF ICMPHDR
;				invoke wsprintf,ADDR ShowBuffer,ADDR MessageData,ebx,esi
				invoke ShowData,esi
			.endif
			invoke SetFocus,hMessage
		.endif
	.endif
.ELSEIF uMsg==WM_DESTROY
	invoke PostQuitMessage,0
.ELSEIF uMsg==WM_CREATE
	invoke CreateWindowEx,0,ADDR StaticClass,ADDR Label1,WS_CHILD+WS_VISIBLE,10,0,100,20,hWnd,Id_Label1,hInstance,0
	invoke CreateWindowEx,0,ADDR StaticClass,ADDR Label2,WS_CHILD+WS_VISIBLE,10,220,100,20,hWnd,Id_Label2,hInstance,0
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,0,WS_CHILD+WS_VISIBLE+ES_READONLY+ES_MULTILINE,10,20,325,200,hWnd,Ctrl_Data,hInstance,0
	mov hDataView,eax
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR EditClass,0,WS_CHILD+WS_VISIBLE,10,240,325,25,hWnd,Ctrl_Msg,hInstance,0
	mov hMessage,eax
	invoke CreateWindowEx,0,ADDR ButtonClass,ADDR SendBtn,WS_CHILD+WS_VISIBLE+BS_DEFPUSHBUTTON,235,270,100,25,hWnd,Ctrl_Send,hInstance,0
	mov hSend,eax
	mov incoming.sin_family,AF_INET
	mov outgoing.sin_family,AF_INET

	mov incoming.sin_port,0
	mov outgoing.sin_port,0

	mov readfds.fd_count,1
	mov TimeOut.tv_sec,5
	mov TimeOut.tv_usec,0

	invoke GetMenu,hWnd
	mov hMenu,eax
	invoke GetSubMenu,eax,0
	mov hFileMenu,eax
.ELSE
	invoke DefWindowProc,hWnd,uMsg,wParam,lParam
	ret
.ENDIF
xor eax,eax
Ret
WndProc Endp
ConnectDlgProc proc hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
.IF uMsg==WM_INITDIALOG
	invoke SendDlgItemMessage,hDlg,Ctrl_Host,EM_SETLIMITTEXT,255,0
	invoke SendDlgItemMessage,hDlg,Ctrl_Nick,EM_SETLIMITTEXT,60,0
	invoke GetDlgItem,hDlg,Ctrl_Host
	invoke SetFocus,eax
;	invoke GetFocus
;	invoke SendDlgItemMessage,hDlg,Ctrl_Host,WM_SETFOCUS,0,0
.ELSEIF uMsg==WM_COMMAND
	mov eax,wParam
	.if ax==Ctrl_Connect
		invoke GetDlgItemText,hDlg,Ctrl_Host,ADDR HostBuffer,255
		.if eax==0
			invoke MessageBox,hDlg,ADDR Err_EnterHost,ADDR AppName,MB_ICONINFORMATION+MB_OK
			ret
		.endif
		invoke GetDlgItemText,hDlg,Ctrl_Nick,ADDR NickName,255
		.if eax==0
			invoke MessageBox,hDlg,ADDR Err_EnterNick,ADDR AppName,MB_ICONINFORMATION+MB_OK
			ret
		.endif
		invoke inet_addr,ADDR HostBuffer
		.if eax==INADDR_NONE
			invoke gethostbyname,ADDR HostBuffer
			.if eax==0
				invoke MessageBox,hDlg,ADDR Err_NoHost,ADDR AppName,MB_ICONINFORMATION+MB_OK
				ret
			.endif
			mov eax,(hostent ptr [eax]).h_list
			mov eax,[eax]
			mov eax,[eax]
		.endif
		mov hostAddr,eax
		invoke SendMessage,hDlg,WM_CLOSE,1,0
	.elseif ax==IDCANCEL
		invoke SendMessage,hDlg,WM_CLOSE,0,0
	.endif
.ELSEIF uMsg==WM_CLOSE
	invoke EndDialog,hDlg,wParam
.ELSE
	xor eax,eax
	ret
.ENDIF
mov eax,TRUE
Ret
ConnectDlgProc EndP
NickDlgProc proc hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
.IF uMsg==WM_INITDIALOG
	invoke SendDlgItemMessage,hDlg,Ctrl_Nick,EM_SETLIMITTEXT,60,0
	invoke GetDlgItem,hDlg,Ctrl_Nick
	invoke SetFocus,eax
;	invoke GetFocus
;	invoke SendDlgItemMessage,hDlg,Ctrl_Host,WM_SETFOCUS,0,0
.ELSEIF uMsg==WM_COMMAND
	mov eax,wParam
	.if ax==Ctrl_Connect
		invoke GetDlgItemText,hDlg,Ctrl_Nick,ADDR NickName,255
		.if eax==0
			invoke MessageBox,hDlg,ADDR Err_EnterNick,ADDR AppName,MB_ICONINFORMATION+MB_OK
			ret
		.endif
		invoke SendMessage,hDlg,WM_CLOSE,1,0
	.elseif ax==IDCANCEL
		invoke SendMessage,hDlg,WM_CLOSE,0,0
	.endif
.ELSEIF uMsg==WM_CLOSE
	invoke EndDialog,hDlg,wParam
.ELSE
	xor eax,eax
	ret
.ENDIF
mov eax,TRUE
Ret
NickDlgProc EndP
ShowData proc data:DWORD
	invoke SendMessage,hDataView,EM_SETSEL,-1,0
	invoke SendMessage,hDataView,EM_REPLACESEL,FALSE,data
	Ret
ShowData EndP
;Contributed by Dude of Dudes 
CheckSum proc pBuffer:dword, lenBuffer:dword

	;calculates the ones complement sum of all the word values in buffer
	;pointed to by pBuffer. lenBuffer is length in bytes.
	;returns checksum in ax in network byte order (NON-little endian)
	xor eax, eax				;zero checksum
	mov edx, pBuffer			;pointer to words

	.while lenBuffer > 1
		xor ecx, ecx
		mov cx, word ptr [edx]		;get next word value
		xchg cl, ch			;convert network byte order to 
						;little endian
		add eax, ecx			;add current word to checksum
		add edx, 2			;point to next word
		sub lenBuffer, 2		;dec counter
	.endw

	.if lenBuffer				;if lenBuffer was odd number
		xor cl, cl			;add 0 padding
		mov ch, byte ptr [edx]	
		add ax, cx			;add last single byte to checksum
	.endif

	;to get the correct one's complement sum of all the words we need to add
	;the carry(s) to the word value 
	mov ecx, eax			
	shr eax, 16				;MSB is in ax
	add ax, cx				;ax holds sum
	not ax					;ax holds one's complement
						;of sum
	xchg al, ah				;put into Network byte order
	Ret
CheckSum EndP
end start